class Filter {
  PImage modifiedImg;
  color c, cc;
  float r, g, b, av, th, th1, th2, th3, th4, th5, th6;

  Filter() {
  }

  void init(PImage img) {
    img.loadPixels();
    this.modifiedImg = createImage(img.width, img.height, RGB);
    this.modifiedImg.loadPixels();
  }

  void bw(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      cc=color(av, av, av);
      //cc=color(av,av,av);
      this.modifiedImg.pixels[i]=cc;
    }//end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  void blur(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(BLUR, 2);
    image(this.modifiedImg, 0, 0, width, height);
  }

  void threshold(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(THRESHOLD, 0.4);
    image(this.modifiedImg, 0, 0, width, height);
  }

  void sepia(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      cc=color(av*1.2, av*0.9, av*0.5);
      this.modifiedImg.pixels[i]=cc;
    }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  void invert(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      cc = color(255-r, 255-g, 255-b);
      this.modifiedImg.pixels[i]=cc;
    }// end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  void posterize(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      this.modifiedImg.pixels[i]=c;
    }
    this.modifiedImg.updatePixels();
    this.modifiedImg.filter(POSTERIZE, 2);
    image( this.modifiedImg, 0, 0, width, height);
  }

  void warhol1(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av=(r+g+b)/3;
      if (av>128) {
        // cc=color(av*1.2,av*0.9,av*0.5);}
        cc=color(av*5, av*0.5, av*0.5);
      }
      else {
        cc=color(255, 255, 0);
      }
      this.modifiedImg.pixels[i]=cc;
    }//end for

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }

  void warhol2(PImage img) {
    this.init(img);

    for (int i=0;i<img.pixels.length;i++) {
      c=img.pixels[i];
      r = red (c);
      b = blue (c);
      g = green (c);
      av = (r+g+b)/3;
      if (av<20) {
        th1=255;
        th2=0;
        th3=0;
      }
      else {
        if (av>128) {
          th1=100;
          th2=255;
          th3=0;
        }
        else {
          th1=255;
          th2=255;
          th3=0;
        }
      }
      cc = color(th1, th2, th3);
      this.modifiedImg.pixels[i]=cc;
    }

    this.modifiedImg.updatePixels();
    image(this.modifiedImg, 0, 0, width, height);
  }
}//end class

